﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Dynamic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DataGridDemo
{
    public class ViewModel : NotificationObject
    {
       internal  OrderInfoRepository order;
        private object dataGridSelectedItem;
        private Random random = new Random();
        private bool isBusy;

        public ViewModel()  
        {
            order = new OrderInfoRepository();
            SetRowstoGenerate(50);
        }

        #region ItemsSource

        public bool IsBusy
        {
            get
            {
                return isBusy;
            }
            set
            {
                this.isBusy = value;
            }
        }
        private ObservableCollection<OrderInfo> ordersInfo;
        public ObservableCollection<OrderInfo> OrdersInfo
        {
            get { return ordersInfo; }
            set { this.ordersInfo = value;
                RaiseCollectionChanged("OrdersInfo");
            }
        }

        private ObservableCollection<OrderInfo> selectedItems;
        public ObservableCollection<OrderInfo> SelectedItems
        {
            get { return this.selectedItems; }
            set
            {
                this.selectedItems = value;
                RaisePropertyChanged("SelectedItems");
            }
        }
        public object DataGridSelectedItem
        {
            get
            {
                return dataGridSelectedItem;
            }
            set
            {
                this.dataGridSelectedItem = value;
                RaisePropertyChanged("DataGridSelectedItem");
            }
        }

        public void ItemsSourceRefresh()
        {
            int count = random.Next(1, 6);

            for (int i = 11000; i < 11000 + count; i++)
            {
                int value = i + random.Next(100, 150);
                this.OrdersInfo.Insert(0, order.RefreshItemsource(value));
            }
        }

        #endregion

        #region ItemSource Generator

        public void SetRowstoGenerate(int count)
        {
            OrdersInfo = order.GetOrderDetails(count);
        }

        #endregion
    }

    public class NotificationObject : INotifyPropertyChanged, INotifyCollectionChanged
    {
        public void RaisePropertyChanged(string propName)
        {
            if (this.PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(propName));
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaiseCollectionChanged(string propName)
        {
            if (this.CollectionChanged != null)
                this.CollectionChanged(this, new NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Reset));
        }
        public event NotifyCollectionChangedEventHandler CollectionChanged;
    }
}
